<?php

	header('Content-Type: text/html; charset=utf-8');
	require_once ('../../../wp-config.php');
	
	$choices = get_option('kau-boys_autocompleter_choices');
	$framework = get_option('kau-boys_autocompleter_framework');
	if(empty($choices)) $choices = 10;
	if(empty($framework)) $framework = 'jQuery';
	
	//$words = '%'.implode('%', explode(' ', $_REQUEST['q'])).'%';
	$words = '%'.$_REQUEST['q'].'%';

	$posts = $wpdb->get_results(
		'	SELECT 		*
			FROM 		'.$wpdb->posts.'
			WHERE 		(	post_title LIKE "'.$words.'"
							OR 	post_content LIKE "'.$words.'"
						)
						AND post_status = "publish"
			ORDER BY 	post_date DESC
			LIMIT		0, '.$choices);

	if($framework == 'scriptaculous'){
		echo "<ul>";
		foreach ($posts as $key => $post) {
			setup_postdata($post);
			$title = strip_tags(get_the_title());
			$content = strip_tags(strip_shortcodes(get_the_content()));
			if(stristr($title.$content, $_REQUEST['q']) !== false){
				echo '	<li>
							<a href="'.get_permalink().'"></a>
							<span class="title">'.highlightSearchString(strtruncate($title, 50, true), $_REQUEST['q']).'</span>
							<p>'.highlightSearchString(strtruncate($content, 120, false, '[...]', $_REQUEST['q']), $_REQUEST['q']).'</p>
						</li>';
			}
		}	
		echo "</ul>";
	} else {
		foreach ($posts as $key => $post) {
			setup_postdata($post);
			$title = strip_tags(get_the_title());
			$content = strip_tags(strip_shortcodes(get_the_content()));
			if(stristr($title.$content, $_REQUEST['q']) !== false){
				echo str_replace(
						array("\n", "\r"),
						array(' ', ' '),
						'<span class="title">'.strtruncate(get_the_title(), 50, true).'</span><p>'.strtruncate($content, 120, false, '[...]', $_REQUEST['q']).'</p><span style="display: none;">|||'.get_permalink().'</span>')."\n";
			}
		}
	}
	
	function highlightSearchString($value, $searchString){
		$regex_chars = '\.+?(){}[]^$';
		for ($i=0; $i<strlen($regex_chars); $i++) {
			$char = substr($regex_chars, $i, 1);
			$searchString = str_replace($char, '\\'.$char, $searchString);
		}
		$searchString = '(.*)('.$searchString.')(.*)';
		return eregi_replace($searchString, '\1<span class="highlighted">\2</span>\3', $value);
	}
	
	function strtruncate($str, $length = 50, $cutWord = false, $suffix = '...', $needle = ''){
		$str = html_entity_decode($str);
		if(mb_strlen(trim(htmlentities($str)))>$length){
			if(!empty($needle) && mb_stripos($str, $needle) > 0){
				$pos = mb_stripos($str, $needle) + (mb_strlen($needle) / 2);
				$start = $pos - ($length / 2) - mb_strlen($suffix);
				$string = mb_strcut($str, (($start > 0)? $start : 0), ($pos + ($length / 2) + mb_strlen($suffix) + (mb_strlen($needle) /2) - (($start > 0)? $start : 0)), "UTF-8");
				return $suffix.' '.(($cutWord) ? $string : mb_substr($string, mb_stripos($string, ' '), (mb_strripos($string, ' ') - mb_stripos($string, ' ')), "UTF-8")).' '.$suffix;
			} else {
				$string = mb_strcut($str, 0, $length - mb_strlen($suffix), "UTF-8");
				return (($cutWord) ? $string : mb_substr($string, 0, mb_strripos($string, ' '), "UTF-8")).' '.$suffix;
			}
		} else {
			return $str;	
		}
	}
	
?>